//
// Created by sebastien lato on 2024-02-08.
//
#include "io_utils.h"
#include <cstdio>

/**
 * @brief Vide le tampon d'entrée standard.
 *
 * @details Cette fonction est appelée après la lecture de l'entrée pour s'assurer
 *          qu'aucun caractère résiduel ne reste dans le tampon d'entrée standard.
 *
 * INPUT: aucun
 * OUTPUT: aucun
 */
void clearStdinBuffer() {
    int c;
    while ((c = std::getchar()) != '\n' && c != EOF) {}
}
