//
// Created by sebastien lato on 2024-02-08.
//
#include "io_utils.h"
#include <iostream>
#include <limits>

/**
 * @brief Demande à l'utilisateur d'entrer un nombre de termes qui est un multiple de 100.
 *
 * @details Cette fonction invite l'utilisateur à saisir une valeur entière positive qui doit être un multiple de 100.
 *          Si l'utilisateur entre une valeur qui n'est pas un multiple de 100 ou un nombre non valide,
 *          la fonction affiche un message d'erreur et redemande une valeur jusqu'à ce qu'une entrée valide soit reçue.
 *
 * INPUT: aucun (la valeur est lue depuis l'entrée standard)
 * OUTPUT: int (le nombre de termes validé qui est un multiple de 100)
 */
int demanderMultipleDeCent() {
    int n;
    std::cout << "Entrez un nombre de termes qui est un multiple de 100 (100, 1000, 10000, ...): \n";
    while (!(std::cin >> n) || n <= 0 || n % 100 != 0) {
        std::cout << "Entrée invalide. Veuillez entrer un multiple positif de 100: ";
        std::cin.clear(); // Réinitialiser le flux
        std::cin.ignore(std::numeric_limits<std::streamsize>::max(), '\n'); // Ignorer les caractères erronés
    }
    return n;
}