//
// Created by sebastien lato on 2024-02-08.
//
#include <iostream>
#include "number_utils.h"

/**
 * @brief Calcule l'epsilon pour les nombres à double précision (double).
 *
 * @details Cette fonction détermine l'epsilon, le plus petit nombre qui,
 *          lorsqu'ajouté à 1.0, donne un résultat différent de 1.0 pour
 *          les nombres à double précision. Elle imprime également le nombre
 *          de chiffres binaires significatifs pour la partie fractionnaire
 *          du type double.
 *
 * INPUT: aucun
 * OUTPUT: aucun (imprime les résultats sur la sortie standard)
 */
void epsilond() {
    double epsilon = 1.0;
    double compteur = 0.0;

    // Diviser par deux jusqu'à ce que l'addition de epsilon à 1 soit indiscernable
    while ((1.0 + (epsilon / 2.0)) != 1.0) {
        epsilon /= 2.0;
        compteur += 1.0;
    }

    std::cout << "Epsilon pour double (double précision): " << epsilon << std::endl;
    std::cout << "Nombre de chiffres binaires significatifs pour la partie fractionnaire: " << compteur << std::endl;
}