//
// Created by sebastien lato on 2024-02-08.
//
#include "io_utils.h"
#include <cstdio>
#include <climits>
#include <cstdlib>

/**
 * @brief Lit une chaîne de caractères de l'utilisateur, la valide et la convertit en short.
 *
 * @details Demande à l'utilisateur d'entrer une valeur, la convertit en short et la valide.
 *          La fonction répète la demande jusqu'à ce qu'une entrée valide soit fournie.
 *
 * INPUT: aucun (la valeur est lue depuis l'entrée standard)
 * OUTPUT: short (la valeur convertie et validée)
 */
short lireShortValidationETConversion() {
    char chaineAconvertir[100];
    long int nombreConverti;
    char *finPtr;

    std::printf("Introduire une valeur entiere entre -2^15 et (2^15) - 1: \n");

    while (std::fgets(chaineAconvertir, sizeof(chaineAconvertir), stdin)) {
        nombreConverti = std::strtol(chaineAconvertir, &finPtr, 10);

        if (finPtr != chaineAconvertir && *finPtr == '\n' && nombreConverti >= SHRT_MIN && nombreConverti <= SHRT_MAX) {
            return static_cast<short>(nombreConverti);
        } else {
            std::printf("Erreur : Entree non valide ou hors plage. Veuillez reessayer.\n");
        }
    }
    return 0; // En cas d'erreur de lecture, on retourne 0
}