//
// Created by sebastien lato on 2024-02-08.
//
#include <iostream>
#include "number_utils.h"

/**
 * @brief Calcule et affiche la sommation ascendante de la série harmonique jusqu'à n en double précision.
 *
 * @details Cette fonction réalise une sommation ascendante (de 1 à n) de la série harmonique,
 *          où chaque terme est de la forme 1/i avec i allant de 1 à n. La sommation est effectuée
 *          en double précision pour minimiser l'erreur d'arrondi, et le résultat est affiché à l'écran.
 *          La sommation ascendante peut présenter des caractéristiques d'erreur d'arrondi différentes
 *          par rapport à une sommation descendante, en particulier pour des valeurs élevées de n,
 *          en raison de l'ajout de nombres de plus en plus petits à un total cumulatif.
 *
 * INPUT: n (int) - Le nombre de termes de la série harmonique à sommer.
 * OUTPUT: aucun (imprime la somme calculée sur la sortie standard).
 */
void sommeascd(int n) {
    double sum = 0.0;
    for (int i = 1; i <= n; ++i) {
        sum += 1.0 / static_cast<double>(i);
    }
    std::cout << sum;
}