//
// Created by sebastien lato on 2024-02-08.
//
#include <iostream>
#include "number_utils.h"

/**
 * @brief Calcule et affiche la sommation ascendante de la série harmonique jusqu'à n en simple précision.
 *
 * @details Cette fonction effectue une sommation ascendante (de 1 à n) de la série harmonique,
 *          où chaque terme est de la forme 1/i, avec i allant de 1 à n. La sommation est réalisée
 *          en simple précision (float) pour illustrer l'impact de la précision sur le résultat final
 *          de la sommation. Comparée à la sommation en double précision, cette méthode peut montrer
 *          une différence notable dans le résultat final pour des valeurs élevées de n, en raison
 *          des erreurs d'arrondi accumulées durant la sommation.
 *
 * INPUT: n (int) - Le nombre de termes de la série harmonique à sommer.
 * OUTPUT: aucun (imprime la somme calculée sur la sortie standard).
 */
void sommeascf(int n) {
    float sum = 0.0f;
    for (int i = 1; i <= n; ++i) {
        sum += 1.0f / static_cast<float>(i);
    }
    std::cout << sum;
}