//
// Created by sebastien lato on 2024-02-08.
//
#include <iostream>
#include "number_utils.h"

/**
 * @brief Effectue une sommation successive de 1/n en double précision (double).
 *
 * @details Cette fonction calcule la somme de 1/n pour n termes en utilisant le type double.
 *          Elle affiche ensuite la valeur de n, le résultat de la sommation et l'erreur de calcul
 *          en comparant le résultat de la sommation à la valeur théorique attendue.
 *
 * @param n Le nombre de termes dans la sommation, qui doit être un multiple de 100.
 */
void sommed(int n) {
    double somme = 0.0;
    for (int i = 1; i <= n; ++i) {
        somme += 1.0 / static_cast<double>(i);
    }
    double erreur = std::abs(somme - log(n + 1));
    std::cout << "sommed (double précision) pour n = " << n << ":\n";
    std::cout << "Somme: " << somme << "\n";
    std::cout << "Erreur de calcul: " << erreur << "\n\n";
}