//
// Created by sebastien lato on 2024-02-08.
//
#include <iostream>
#include "number_utils.h"

/**
 * @brief Calcule et affiche la sommation descendante de la série harmonique jusqu'à n en double précision.
 *
 * @details Cette fonction effectue une sommation descendante (de n à 1) de la série harmonique,
 *          où chaque terme est de la forme 1/i, avec i décroissant de n jusqu'à 1. La sommation est réalisée
 *          en double précision pour minimiser l'erreur d'arrondi. Cette approche de sommation descendante
 *          peut réduire les erreurs d'arrondi pour certains types de séries numériques en comparaison
 *          avec une sommation ascendante, car elle commence par les termes les plus petits, réduisant ainsi
 *          l'impact de l'ajout de petits nombres à un total plus grand.
 *
 * INPUT: n (int) - Le nombre de termes de la série harmonique à sommer.
 * OUTPUT: aucun (imprime la somme calculée sur la sortie standard).
 */
void sommedescd(int n) {
    double sum = 0.0;
    for (int i = n; i >= 1; --i) {
        sum += 1.0 / static_cast<double>(i);
    }
    std::cout << sum;
}