/*
OUATTARA SOTIGUI
MATHURIN RONIDE

*/

// Definitions de constantes, prototypes de fonctions
// Fonctions utilitaires permettant de calculer la racine d'une fonction parabolique
// donnant la distance horizontale (x) parcourue par une balle


#include <math.h>
#include <stdio.h>
#include <stdlib.h>

// Definition de constantes utiles
#define MAXIT 100
#define PI 3.14159
#define G 9.81
#define PRECISIONX 6
#define PRECISIONZERO 7

double F(double x, double theta0, double v0, double y0);
double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc);

void someascf(){

}

int main()
{
   PRECISIONX;
   PRECISIONZERO;

   printf("\n Valeur de la racine (bissection) = %lf m.", rtbis(1, 300, 30, 50, 2, PRECISIONX, PRECISIONZERO));
}

// Exemple d'appel permettant le calcul de la distance en x parcourue par une balle
// Parametre 1 x1: borne inferieure des valeurs en x (m)
// Parametre 2 x2: borne superieure des valeurs en x (m)
// Parametre 3 theta0: angle en degre par rapport de la direction de la balle au depart
// Parametre 4 v0: vitesse initiale (m/s)
// Parametre 5 y0: hauteur de la balle au depart (m)
// Parametre 6 xacc: precision sur la localisation de la racine en x
// Parametre 7 zeroacc: précision sur la localisation du 0 de fonction (en y)

//printf("\n Valeur de la racine (bissection) = %lf m.", rtbis(1, 300, 30, 50, 2, PRECISIONX, PRECISIONZERO));


/*
Fonction qui calcule la valeur de la fonction parabolique, qui calcul la position y (hauteur) d'une balle sur sa
trajectoire en x
*/

double F(double x, double theta0, double v0, double y0)
{
	return (tan(theta0*PI/180.0)*x-((G/(2.0*v0*v0*cos(theta0*PI / 180.0)*cos(theta0*PI / 180.0)))*x*x)+y0);
}

/*
Fonction qui calcule la valeur de la position x  pour y = 0 donnant la distance parcourue  d'une balle
*/

double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc)
{
	int j;
	float dx, f, fmid, xmid, rtb;


	f = F(x1, theta0, v0, y0);
	fmid = F(x2, theta0, v0, y0);
	if (f*fmid >= 0.0) printf("Racine absente de cet intervalle dans RTBIS\n");
	rtb = f < 0.0 ? (dx = x2 - x1, x1) : (dx = x1 - x2, x2);
	for (j = 1; j <= MAXIT; j++) {
		fmid = F(xmid = rtb + (dx *= 0.5), theta0, v0, y0);
		if (fmid <= 0.0) rtb = xmid;
		if (fabs(dx) < xacc || fabs(fmid) < zeroacc)
		{
			printf("\nNombre d'iterations: %d dx: %17.15lf f(rtb): %17.15lf", j,dx,fmid);
			return rtb;
		}
	}
	printf("Trop de bissections dans RTBIS\n");
    return 0;
}


