#include <stdio.h>
#include <limits.h>
#include <math.h>
#include "fonction.h"

/* additionSINT()- Calcule la somme de deux nombres entiers signés sur 16 bits.
Cette fonction demande a l'utilisateur de fournir deux nombres entiers signés sur 16 bits
et calcule leur somme. Elle verifie également s'il y a un debordement positif ou négatif.
ici la plage a respecter est : -32768 a 32767. */

void additionSINT(){

    //DECLARATION DES VARIABLES LOCALES
    short int n1, n2, sum; 

    //DEMANDE A L'UTILISATEUR DE FOURNIR DEUX NOMBRES ENTIERS SIGNÉS 
    printf("Entrez le premier nombre entier signé sur 16 bits : ");
    scanf("%hd", &n1);

    printf("Entrez le deuxiéme nombre entier signé sur 16 bits : ");
    scanf("%hd", &n2);

    //ADDITIONNER LES DEUX NOMBRES 
    sum = n1 + n2; 

    //VERIFIONS S'IL Y A UN DEBORDEMENT POSITIF OU NEGATIF 
    /* 
    LES CAS DE DEBORDEMENT: 
      **DEBORDEMENT POSITIF 
    -- Si les deux nombres sont positifs et le résultat est négatif, il y a un débordement positif.
   
      **DEBORDEMENT NEGATIF
    -- Si les deux nombres sont négatifs et le résultat positif, il y a un débordement négatif. 
    */

   if (n1 > 0 && n2 > 0 && sum < 0)
   {
    printf("\n Debordement positif : ");
    printf("\n n1 = %hd", n1);
    printf("\n n2 = %hd", n2);
    printf("\n n1 + n2 = %hd\n", sum);
   }
   else if (n1 < 0 && n2 < 0 && sum >= 0)
   {
    printf("\n Debordement négatif : ");
    printf("\n n1 = %hd", n1);
    printf("\n n2 = %hd", n2);
    printf("\n n1 + n2 = %hd\n", sum);
   }
   else
   {
    printf("\n Resultat ok : ");
    printf("\n n1 = %hd", n1);
    printf("\n n2 = %hd", n2);
    printf("\n n1 + n2 = %hd\n", sum);
   }
}

/* epsilonf()- Représentation réelle simple précision (SP)(float) 
   epsilond()- Représentation double précision (DP)(double)
   ces deux fonctions doivent calculer et afficher la valeur de l'epsilon 
   ainsi que le nombre de chiffres binaires significatifs. */

//FONCTION EPSILONF() ET LE NOMBRE DE CHIFFRES BINAIRES POUR FLOAT 
void epsilonf(){
    float epsilon = 1;  
    while( 1 + epsilon > 2 )
    {
        epsilon /= 2;
    }
    int nb_chiffres_significatifs = 0;
    while (epsilon < 1 )
    {
        epsilon *= 2;
        nb_chiffres_significatifs++;
    }
    printf("epsilon pour float : %e \n", epsilon);
    printf("nombre de chiffres binaires significatifs pour float : %d \n", nb_chiffres_significatifs);
}   

//FONCTION EPSILOND() ET LE NOMBRE DE CHIFFRES BINAIRES POUR DOUBLE 
void epsilond(){
    double epsilon = 1;
    while( 1 + epsilon > 2 )
    {
        epsilon /= 2;
    }
    int nb_chiffres_significatifs = 0;
    while (epsilon < 1)
    {
        epsilon *= 2;
        nb_chiffres_significatifs++;
    }
    printf("epsilon pour double : %e \n", epsilon);
    printf("nombre de chiffres binaires significatifs pour double : %d \n", nb_chiffres_significatifs);
}

/* sommef()- Pour le cas de nombres réels SP
   sommed()- Pour le cas de nombres réels DP
   ces deux fonctions calculent la sommation sucessive de 1/n pour n itérations */

   //FONCTION SOMMEF() POUR CALCULER LA SOMME SUCCESSIVE POUR FLOAT
   void sommef(){
    int n;
    printf("Entrez le nombres d'itération (multiple de 100) : ");
    scanf("%d", &n);

    while (n % 100 != 0)
    {
        printf("Le nombre d'interations doit etre un multiple de 100 \n");
        printf("voulez entrer le nombre d'itérations (multiple de 100) : ");
        scanf("%d" , &n);
    }
    
    float somme = 0.0f;
    for (int i = 1; i <= n; i++){
        somme += 1.0f / i; 
    }    

    float error = fabsf( somme - logf(n));

    printf("Nombre d'intération : %d \n", n);
    printf("Résultat de la sommation : %e \n", somme);
    printf("Erreur de calcul : %e \n", error);
   }

  //FONTION SOMMED() POUR CALCULER LA SOMME SUCCESSIVE POUR DOUBLE 
  void sommed(){
    int n;
    printf("Entrez le nombres d'itération (multiple de 100) : ");
    scanf("%d", &n);

     while (n % 100 != 0)
    {
        printf("Le nombre d'interations doit etre un multiple de 100 \n");
        printf("voulez entrer le nombre d'itérations (multiple de 100) : ");
        scanf("%d", &n);
    }

    double somme = 0.0;
    for (int i = 1; i <= n; i++){
        somme += 1.0 / i; 
    }    

    double error = fabs( somme - log(n));

    printf("Nombre d'intération : %d \n", n);
    printf("Résultat de la sommation : %e \n", somme);
    printf("Erreur de calcul : %e \n", error);
  }

/* sommeascf()- Qui permet la sommation ascendante de nombres réels(SP)
   sommedescf()- Qui permet la sommation descendante de nombres réels(SP)
   sommeascd()- Qui permet la sommation ascendante de nombres réels (DP)
   sommedescd()- Qui permet la sommation descendante de nombrres réels (DP)
   Ces fonctions doivent afficher la valeur de n et le résultat de la sommation */  

   //SOMMEASCF(): SOMMATION ASCENDANTE FLOTTANTE DE 1/i^n
   void sommeascf(float n){
    int i, N = 32767;
    float somme = 0;
    for (i = 1; i <= N; i++){
        somme += 1.0 / pow(i, n);
    }
    printf("\n somme asc (float) %20.15f0000000000000000 Pour n = %.6f \n", somme, n);
   }

   //SOMMEDESCF(): SOMMATION DESCENDANTE FLOTTANTE DE 1/i^n
   void sommedescf(float n){
    int i, N = 32767;
    float somme = 0;
    for (i = 1;  i >= N; i--){
        somme += 1.0 / pow(i, n);
    }
    printf("\n somme desc (float) %20.151f0000000000000000 Pour n = %.6f \n", somme, n);
   }

   //SOMMEASCD(): SOMMATION DESCENDANTE DOUBLE DE 1/i^n
   void sommeascd(double n){
     int i, N = 32767;
    double somme = 0;
    for (i = 1; i <= N; i++){
        somme += 1.0 / pow(i, n);
    }
    printf("\n somme asc (double) %20.151f0000000000000000 Pour n = %.6f \n", somme, n);
   }

   //SOMMEDESCS(): SOMMATION DESCENDANTE DOUBLE DE 1/i^n
   void sommedescd(double n){
    int i, N = 32767;
    double somme = 0;
    for ( i = N; i >= 1; i--)
    {
        somme += 1.0 / pow(i, N);
    }
    printf("\n somme desc (double) %20.151f0000000000000000 Pour n = %.6f \n", somme, n);
   }

   /* rtbis()- Pour afficher la distance horizontale parcourue par une balle (projectile) par rapport a une trajectoire parabolique
   parametres : PRECISIONX et PRECISIONZERO */

    // Exemple d'appel permettant le calcul de la distance en x parcourue par une balle
    // Parametre 1 x1: borne inferieure des valeurs en x (m)
    // Parametre 2 x2: borne superieure des valeurs en x (m)
    // Parametre 3 theta0: angle en degre par rapport de la direction de la balle au depart
    // Parametre 4 v0: vitesse initiale (m/s)
    // Parametre 5 y0: hauteur de la balle au depart (m)
    // Parametre 6 xacc: precision sur la localisation de la racine en x
    // Parametre 7 zeroacc: pr�cision sur la localisation du 0 de fonction (en y)

    // Fonction QUI CALCULE LA PORTÉE D'UNE PROJECTILE POUR UN ANGLE DONNÉ
    double F(double x, double theta0, double v0, double y0)
    {
	    return (tan(theta0*M_PI/180.0)*x-((g/(2.0*v0*v0*cos(theta0*M_PI / 180.0)*cos(theta0*M_PI / 180.0)))*x*x)+y0);
    }

    //F0NCTION QUI CALCULE LA POSITION DE X POUR Y = 0 DONNANT LA DISTANCE PARCOURUE D'UNE BALLE 

    double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc){
        int j;
	    double dx, f, fmid, xmid, rtb;


	  f = F(x1, theta0, v0, y0);
	  fmid = F(x2, theta0, v0, y0);
	  if (f*fmid >= 0.0) printf("Racine absente de cet intervalle dans RTBIS\n");
	  rtb = f < 0.0 ? (dx = x2 - x1, x1) : (dx = x1 - x2, x2);
	  for (j = 1; j <= MAXIT; j++)
      {
		fmid = F(xmid = rtb + (dx *= 0.5), theta0, v0, y0);
		if (fmid <= 0.0) rtb = xmid;
		if (fabs(dx) < xacc || fabs(fmid) < zeroacc)
		{
			printf("\nNombre d'iterations: %d dx: %17.15lf f(rtb): %17.15lf", j,dx,fmid);
			return rtb;
		}
	  }
	    printf("Trop de bissections dans RTBIS\n");
        return rtb;
    }

