/*
 ====================================================================================================
             TP1 : Architecture des ordinateurs
 Auteurs : [Ehui Assama : EHUA90530000],
           [Diomande Mahoua Ilma : DIOM92300400],
           [Alimatou Sow: Sowa84330100],
           [Houé Dicardie Precious Netty:HOUD72560400],
                    EXERCICE 4
 =====================================================================================================
 */

#include <stdio.h>
#include <math.h>

// Prototypes de fonction
void sommeascf(int n);
void sommedescf(int n);
void sommeascd(int n);
void sommedescd(int n);

int main() {
    // Test des fonctions pour n = 1, 2, 3
    for (int n = 1; n <= 3; n++) {
        sommeascf(n); 
        sommedescf(n); 
        sommeascd(n); 
        sommedescd(n); 
    }
    return 0;
}

// Fonction pour la sommation ascendante en simple précision (SP)
void sommeascf(int n) {
    float sum_result = 0.0f;
    for (int i = 1; i <= 32767; i++) {
        sum_result += 1.0f / pow(i, n);
    }
    printf("n = %d, Somme ascendante (SP) = %f\n", n, sum_result);
}

// Fonction pour la sommation descendante en simple précision (SP)
void sommedescf(int n) {
    float sum_result = 0.0f;
    for (int i = 32767; i >= 1; i--) {
        sum_result += 1.0f / pow(i, n);
    }
    printf("n = %d, Somme descendante (SP) = %f\n", n, sum_result);
}

// Fonction pour la sommation ascendante en double précision (DP)
void sommeascd(int n) {
    double sum_result = 0.0;
    for (int i = 1; i <= 32767; i++) {
        sum_result += 1.0 / pow(i, n);
    }
    printf("n = %d, Somme ascendante (DP) = %lf\n", n, sum_result);
}

// Fonction pour la sommation descendante en double précision (DP)
void sommedescd(int n) {
    double sum_result = 0.0;
    for (int i = 32767; i >= 1; i--) {
        sum_result += 1.0 / pow(i, n);
    }
    printf("n = %d, Somme descendante (DP) = %lf\n", n, sum_result);
}
