/*
 ====================================================================================================
              TP1 : Architecture des ordinateurs
 Auteurs : [Ehui Assama : EHUA90530000],
           [Diomande Mahoua Ilma : DIOM92300400],
           [Alimatou Sow: Sowa84330100],
           [Houé Dicardie Precious Netty:HOUD72560400],
                    EXERCICE 5
 =====================================================================================================
 */
#include <stdio.h>
#include <math.h>

#define MAXIT 1000

// Fonction qui calcule la position verticale de la balle en fonction de la position horizontale x
double F(double x, double theta0, double v0, double y0) {
    // Implémentation de la trajectoire parabolique
    return y0 + x * tan(theta0) - (9.81 * x * x) / (2 * v0 * v0 * cos(theta0) * cos(theta0));
}

//Fonction qui calcule la valeur de la position x  pour y = 0 donnant la distance parcourue  d'une balle
//Apres avoir attribuer la valeur 100 aux parametres 6 et 7 ,on constate que la valeur de la racine augument , dx diminue et f(rtb) augumente

double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc)
{
    int j;
    double dx, f, fmid, xmid, rtb;

    f = F(x1, theta0, v0, y0);
    fmid = F(x2, theta0, v0, y0);
    if (f * fmid >= 0.0) printf("Racine absente de cet intervalle dans RTBIS\n");
    rtb = f < 0.0 ? (dx = x2 - x1, x1) : (dx = x1 - x2, x2);
    for (j = 1; j <= MAXIT; j++) {
        fmid = F(xmid = rtb + (dx *= 0.5), theta0, v0, y0);
        if (fmid <= 0.0) rtb = xmid;
        if (fabs(dx) < xacc || fabs(fmid) < zeroacc)
        {
            printf("\nNombre d'iterations: %d dx: %17.15lf f(rtb): %17.15lf", j, dx, fmid);
            return rtb;
        }
    }
    printf("Trop de bissections dans RTBIS\n");
    return 0;
}

int main() {
    double x1 = 0;
    double x2 = 10; 
    double theta0 = 40; 
    double v0 = 10; 
    double y0 = 0; 
    double xacc = 0.001; 
    double zeroacc = 0.001; 

    double distance = rtbis(x1, x2, theta0, v0, y0, xacc, zeroacc);

    printf("\nDistance horizontale parcourue par la balle : %lf m\n", distance);

    return 0;
}