/*	
	 _______________________________________
	|	Nom			|	Frdrick Prusse	|
	|	Code Perm.	|	PERF20358800		|
	|	Cours		|	SIF-1053			|
	|	quipier	|	0					|
	|_______________|_______________________|

*/
#include <stdio.h>      // Oprations d'entre et de sortie ex: printf et getchar.
#include <limits.h>     // Contient les limites des types de donnes ex: SHRT_MAX et SHRT_MIN.
#include <math.h>		// Fonctions mathmatiques avances
#include <stdlib.h>		// Fonction system
#include <locale.h>		// Setlocal pour encodage de caractres

//  Pause avant le retour au menu  --------------------------------------------------------------------------------------------------------
//	Description: On demande  l'utilisateur d'appuyer sur une touche pour continuer, cela facilite l'utilisation du menu.
void pauseContinuer() {
	printf("\nAppuyez sur ENTRER pour continuer...\n");
	(void)getchar(); // Attend une saisie clavier de l'utilisateur.
}

//  Netoyer la console  -------------------------------------------------------------------------------------------------------------------
//  Description: Efface le contenu de la console avant le retour au menu. Utilise "cls" (Windows) et "clear" (Unix/Linux/macOS). 
void nettoyerConsole() {
#ifdef _WIN32
	system("cls");
#else
	system("clear");
#endif
}

//	Couleurs ANSI  ------------------------------------------------------------------------------------------------------------------------
//	Description: Change la couleur du texte affich dans la console en utilisant des squences d'chappement ANSI.
//	INPUT: message - const char*, le message  afficher. (codeCouleur - const char*)
//  Aide: https://www.codequoi.com/colorer-le-texte-du-terminal-tput-et-sequences-ansi/
void printfEnCouleur(const char* message, const char* codeCouleur) {
	printf("%s%s\033[0m\n", codeCouleur, message); // Applique la couleur, affiche le message, rinitialise la couleur.
}
// Liste des couleurs
#define ROUGE "\033[1;31m"
#define VERT "\033[1;32m"
#define BLEU "\033[1;34m"      
#define GRIS "\033[1;30m"
#define RESET "\033[0m"

//	NONC #1  ----------------------------------------------------------------------------------------------------------------------------
//	Fonctions: [shortValidationConversion], [additionSINT] 

//	[shortValidationConversion]
//	Titre: Validation de l'entre et conversion
// 
//	Description: Lit une chane et la convertit en short int, tout en validant que la valeur est dans la plage autorise pour un short int. 
//               On demande  l'utilisateur de ressaisir si l'entre est invalide ou hors plage.
// 
//	INPUNT: - prompt (const char*, passage par pointeur) : Message affich  l'utilisateur.
// 
//	OUTPUT: - Retour (short) : Retourne un short int converti et valid.

short shortValidationConversion(const char* prompt) {
	long nombreTemporaire;
	int resultat;

	printf("%s", prompt); // Message pour chaque valeur (Valeur #1/Valeur #2)
	while (1) { // On rpte la boucle indfiniment
		resultat = scanf_s("%ld", &nombreTemporaire);

		// Vrifie si la conversion a russi
		if (resultat == 1) {
			break; // Sortie de la boucle si -> valide
		}
		else {
			printf("Entre invalide, veuillez introduire un nombre entier sign compris dans la plage.\n");
			while (getchar() != '\n');
			printf("%s", prompt); // On rpte le messagee
		}
	}
	while (getchar() != '\n');
	return (short)nombreTemporaire; //CASTING de la variable nombreTemporaire (long) -> en short.
}
//	[additionSINT] 
//	Titre: Dtecter les cas de dbordements positifs et ngatifs
// 
//	Description: Effectue l'addition de deux nombres entiers signs sur 16 bits, vrifie le dbordement, affiche le rsultat.
// 
//	INPUT:  - Aucun, on utilise shortValidationConversion() pour lire les entres.
// 
//	OUTPUT: - Aucune valeur (void).
//			- Les rsultats de l'addition et les dbordements sont affichs directement  la console.
//			- On utilise la fonction printfEnCouleur() pour colorer le message selon le rsultat.

void additionSINT() {
	short n1 = shortValidationConversion("Introduire la premiere valeur entire entre -32768 et 32767 | Valeur #1: ");
	short n2 = shortValidationConversion("Introduire la deuxieme valeur entire entre -32768 et 32767 | Valeur #2: ");
	// On utlise long pour montrer le rsultat attendu (sans dbordement)
	long resultatAttendu = n1 + n2;
	// On utilise short pour montrer le rsultat avec dbordement.
	short resultatAddition = n1 + n2;
	//Dbordement positif
	if (resultatAttendu > SHRT_MAX) {
		printfEnCouleur("\nDbordement positif dtect!", ROUGE);
		printf("Resultat invalide: %d + %d != %d \nLe resultat sans dbordement est: %ld\n", n1, n2, resultatAddition, resultatAttendu);
	}
	//Dbordement negatif
	else if (resultatAttendu < SHRT_MIN) {
		printfEnCouleur("\nDbordement ngatif dtect!", ROUGE);
		printf("Resultat invalide: %d + %d != %d \nLe resultat sans dbordement est: %ld\n", n1, n2, resultatAddition, resultatAttendu);
	}
	//Aucun dbordement
	else {
		printfEnCouleur("\nAucun dbordement.", VERT);
		printf("Le rsultat de la somme est: %d\n", resultatAddition);
	}
	pauseContinuer();
}


//	NONC #2  ----------------------------------------------------------------------------------------------------------------------------
//	Fonctions: [epsilonFloat], [epsilonDouble], [afficherEpsilon]

//	[epsilonFloat]
//	Titre: Calcul de l'Epsilon pour un Float
//	
//	Description: Calcule l'epsilon pour un float puis indiquer la valeur de l'epsilon et le nombre de chiffres binaires significatifs. 
// 
//	INPUT:  - nbs (int*, pointeur) : Pointeur vers une variable o le nombre de bits significatifs sera stock.
// 
//	OUTPUT: - Return (float) : La valeur de l'epsilon, soit la plus petite diffrence dtectable pour un float.

float epsilonFloat(int* nbs) {
	float epsilon = 1.0f;					// Initialisation  1.0 pour un float.
	*nbs = 0;								// nbs = nombre de bits significatifs.


	while ((1.0f + epsilon) != 1.0f) {		// Boucle tant que l'ajout d'epsilon  1.0 est dtectable.
		epsilon /= 2.0f;					// En divisant par 2 on dplacer la virgule d'un bit vers la droite.
		(*nbs)++;							// On ajoute 1 au compteur.
	}
	epsilon *= 2.0f;						// On annule la dernire division par 2 pour retrouver la plus petite valeur encore valide.
	(*nbs)--;								// On reculle le compteur (dcrmentation --) de 1 pour retrouver la plus petite valeur encore valide.
	return epsilon;							// Retourne l'epsilon float.
}


//	[epsilonDouble]
//	Titre: Calcul de l'Epsilon pour un Double
//	
//	Description: Calcule l'epsilon pour un double puis indiquer la valeur de l'epsilon et le nombre de chiffres binaires significatifs. 
//				 *Le procd est le mme que pour le fonction epsilonFloat.
// 
//	INPUT:   - nbs (int*, pointeur) : Pointeur vers une variable o le nombre de bits significatifs sera stock.
// 
//	OUTPUT:  - Return (double) : La valeur de l'epsilon, soit la plus petite diffrence dtectable pour un double.

double epsilonDouble(int* nbs) {
	double epsilon = 1.0;
	*nbs = 0;

	while ((1.0 + epsilon) != 1.0) {
		epsilon /= 2.0;
		(*nbs)++;
	}
	epsilon *= 2.0;
	(*nbs)--;
	return epsilon;
}


//	[afficherEpsilon]
//	Titre: Affichage de l'Epsilon pour Float et Double
//	
//	Description: Affiche les rsultats de epsilonFloat & epsilonFloat. 
// 
//	INPUT:   - AUCUN
// 
//	OUTPUT:  - Aucune valeur de retour (void)
//			 - Les rsultats des calculs (epsilon et nombre de bits significatifs)

void afficherEpsilon() {
	int nbs_float, nbs_double;
	float eps_float = epsilonFloat(&nbs_float);
	double eps_double = epsilonDouble(&nbs_double);

	printf("----------------------------------------\n");
	printf("Float\n");
	printf("Epsilon = %.30e \nBits significatifs = %d\n", eps_float, nbs_float);
	printf("----------------------------------------\n");
	printf("Double\n");
	printf("Epsilon = %.30e \nBits significatifs = %d\n", eps_double, nbs_double);
	printf("----------------------------------------\n");
	pauseContinuer();
}


//	NONC #3  ----------------------------------------------------------------------------------------------------------------------------
//	Fonctions: [sommef], [sommed], [sommationSuccessive] 

//	[sommef]
//	Titre: Sommation et Erreur pour (n) termes en Float
//	
//	Description: Effectue la sommation de (n) termes, chacun gal  (1/n), et calcule l'erreur par rapport  1. 
// 
//	INPUT:   - n (unsigned int) : Le nombre de termes  sommer d'une valeur de 1/n chacun.
// 
//	OUTPUT:  - Aucune valeur de retour (void)
//			 - Les rsultats de la sommation et les erreurs sont affichs directement  la console.

void sommef(unsigned int n) {					// Dfinit une fonction avec comme entier non sign n
	float saut = 1.0f / n;						// Calcule la valeur de chaque saut  (1 / n)
	float somme = 0.0f;							// Initialise la somme  0
	// Exemple du cours : for (i = 1;i<=N;i++)
	for (unsigned int i = 1; i <= n; i++) {		// Boucle de 1  n
		somme += saut;							// Ajoute la valeur des sauts  somme
	}
	float erreur = 1.0f - somme;				// Calcule l'erreur en soustrayant la somme calcule de 1.0 et envoie  erreur.

	printf("Nombre de termes choisi: [%u]\n", n);
	printf("----------------------------------------\n");
	printf("Float\n");
	printf("Sommation: %.30f \nErreur:    %.30f\n", somme, erreur);
}

//	[sommed]
//	Titre: Sommation et Erreur pour (n) termes en Double
//	
//	Description: Effectue la sommation de (n) termes, chacun gal  (1/n), et calcule l'erreur par rapport  1. 
//				 *Le procd est le mme que pour le fonction sommef.
// 
//	INPUT:   - n (unsigned int) : Le nombre de termes  sommer d'une valeur de 1/n chacun.
// 
//	OUTPUT:  - Aucune valeur de retour (void)
//			 - Les rsultats de la sommation et les erreurs sont affichs directement  la console.

void sommed(unsigned int n) {
	double saut = 1.0 / n;
	double somme = 0.0;
	for (unsigned int i = 1; i <= n; i++) {
		somme += saut;
	}
	double erreur = 1.0 - somme;
	printf("----------------------------------------\n");
	printf("Double\n");
	printf("Sommation: %.30f \nErreur:   %.30f\n", somme, erreur);
	printf("----------------------------------------\n");
}


//	NONC #4  ----------------------------------------------------------------------------------------------------------------------------
//	Fonctions: [sommationSuccessive], [sommeascf], [sommedescf], [sommeascd], [sommedescd]

//	[sommationSuccessive]
//	Titre: Saisie & validation de la sommation successive
//	
//	Description: Demande  l'utilisateur de saisir un nombre qui doit tre un multiple de 100 et ne pas dpasser une valeur maximale.
//				 Cette fonction utilise une boucle while pour continuer  demander un nombre tant que les critres ne sont pas respects.
// 
//	INPUT:   - L'utilisateur est invit  saisir un nombre via stdin.
//		     - MaxValide (const unsigned int) : Constante reprsentant la valeur maximale que l'utilisateur peut saisir.
// 
//	OUTPUT:  - Aucune valeur de retour (void)
//			 - Utilise la valeur de l'utilisateur pour appeler sommef et sommed.
//			 - Affiche un messages d'erreur si la saisie de l'utilisateur est invalide.

void sommationSuccessive() {
	unsigned int n;
	const unsigned int MaxValide = 1000000;
	char saisie[20];
	int success;

	do {
		printf("Entrez un multiple de 100 <= %u: ", MaxValide);
		fgets(saisie, sizeof(saisie), stdin);		// Lit une ligne entire de l'entre standard.
		success = sscanf_s(saisie, "%u", &n);		// Essaie de convertir la ligne lue en un nombre unsigned int.

		// Vrifie si la conversion a russi, si n est un multiple de 100 et ne dpasse pas MaxValide.
		if (success != 1 || n % 100 != 0 || n > MaxValide) {
			printf("Le nombre inscrit ne respecte pas les critres.\n");
			success = 0;	 // On set success
		}
	} while (!success);		 // Continue tant que l'entre n'est pas valide (success).

	sommef(n);
	sommed(n);
	pauseContinuer();
}


//	[sommeascf]
//	Titre: Sommation ascendante en Simple Prcision (SP)
//	
//	Description: Effectue la sommation ascendante des inverses des puissances de 1  32767 d'un nombre entier (n) avec powf
// 
//	INPUT:   - n (int, passage par valeur) : L'exposant appliqu  chaque terme de la srie du calcul
// 
//	OUTPUT:  - Aucune valeur de retour (void)
//			 - Affiche le rsultat de la sommation dans la console.

void sommeascf(int n) {
	float somme = 0.0f;								// Initialisation (0 SP)
	for (int i = 1; i <= 32767; i++) {				// Boucle de 1  32767
		// Exemple du cours: somme += 1.0/pow((double) i, (double) n);
		// somme = somme + 1/in
		somme += 1.0f / powf((float)i, (float)n);
	}
	printf("SP^%d Ascendant   -   Somme: %lf\n", n, somme);
}


//	[sommedescf]
//	Titre: Sommation descendante en Simple Prcision (SP)
//	
//	Description: Effectue la sommation descendante des inverses des puissances de 32767  1 d'un nombre entier (n) avec powf.
//				*Le procd est semblable  la fonction sommeascf, mais on inverse la boucle.
// 
//	INPUT:   - n (int, passage par valeur) : L'exposant appliqu  chaque terme de la srie du calcul.
// 
//	OUTPUT:  - Aucune valeur de retour (void)
//			 - Affiche le rsultat de la sommation dans la console.

void sommedescf(int n) {
	float somme = 0.0f;
	for (int i = 32767; i >= 1; i--) {				// Boucle de 32767  1
		somme += 1.0f / powf((float)i, (float)n);
	}
	printf("SP^%d Descendant  -   Somme: %lf\n", n, somme);
}


//	[sommeascd]
//	Titre: Sommation ascendante en Double Prcision (DP)
//	
//	Description: Effectue la sommation ascendante des inverses des puissances de 1  32767 d'un nombre entier (n) avec powf
//				*Le procd est semblable  la fonction sommeascf, mais en double prcision.
// 
//	INPUT: - n (int, passage par valeur) : L'exposant appliqu  chaque terme de la srie du calcul
// 
//	OUTPUT: - Aucune valeur de retour (void)
//			- Affiche le rsultat de la sommation dans la console.

void sommeascd(int n) {
	double somme = 0.0;
	for (int i = 1; i <= 32767; i++) {				// Boucle de 1  32767
		somme += 1.0 / pow((double)i, (double)n);
	}
	printf("DP^%d Ascendant   -   Somme: %lf\n", n, somme);
}


//	[sommedescd]
//	Titre: Sommation descendante en Double Prcision (DP)
//	
//	Description: Effectue la sommation descendante des inverses des puissances de 32767  1 d'un nombre entier (n) avec powf.
//				*Le procd est semblable  la fonction sommedescf, mais en double prcision.
// 
//	INPUT: - n (int, passage par valeur) : L'exposant appliqu  chaque terme de la srie du calcul.
// 
//	OUTPUT:  - Aucune valeur de retour (void)
//			 - Affiche le rsultat de la sommation dans la console.

void sommedescd(int n) {
	double somme = 0.0;
	for (int i = 32767; i >= 1; i--) {				// Boucle de 32767  1
		somme += 1.0 / pow((double)i, (double)n);
	}
	printf("DP^%d Descendant  -   Somme: %lf\n", n, somme);
}


//	NONC #5  ----------------------------------------------------------------------------------------------------------------------------
//	Fonctions: [sommationSuccessive], [sommeascf], [sommedescf], [sommeascd], [sommedescd]
//	Titre: Afficher la distance horizontale parcourue par une balle suivant une trajectoire parabolique

//	[rtbis]
//	Titre: Trouver une Racine
//	
//	Description: On utilise la mthode de bissection pour trouver la racine d'une fonction (F) dans un intervale jusqu' ce que 
//				 l'intervalle de recherche soit infrieur  xacc ou que la valeur de F soit infrieure  zeroacc.
// 
//	INPUT:  - x1	  (double, passage par valeur) : Borne inferieure des valeurs en x (m)
//			- x2	  (double, passage par valeur) : Borne superieure des valeurs en x (m)
//			- theta0  (double, passage par valeur) : Angle en degre par rapport de la direction de la balle au depart de la fonction F.
//			- v0	  (double, passage par valeur) : Vitesse initiale (m/s) de la fonction F.
//			- y0	  (double, passage par valeur) : Hauteur de la balle au depart (m) de la fonction F.
//			- xacc	  (double, passage par valeur) : Precision sur la localisation de la racine en x
//			- zeroacc (double, passage par valeur) : Precision sur la localisation du 0 de fonction (en y)
// 
// 
//	OUTPUT: - Return (double) : La distance horizontale parcourue (Racine dans l'intervalle).

// Dfinitions des constantes
#define MAXIT 100
#define PI 3.14159
#define G 9.81 
#define PRECISIONX 0.000001
#define PRECISIONZERO 0.000001

// Fonctions pour le calcul de la trajectoire
double F(double x, double theta0, double v0, double y0);
double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc);

// Fonction qui calcule la position y (hauteur) d'une balle sur sa trajectoire en x.
double F(double x, double theta0, double v0, double y0) {
	return (tan(theta0 * PI / 180.0) * x - ((G / (2.0 * v0 * v0 * cos(theta0 * PI / 180.0) * cos(theta0 * PI / 180.0))) * x * x) + y0);
}
// [rtbis]
//	FONCTION rtbis bas sur le code fourni: [util - Rtbis - Trajectoire.cpp]
double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc) {
	int j;
	double dx, f, fmid, xmid, rtb;

	f = F(x1, theta0, v0, y0);
	fmid = F(x2, theta0, v0, y0);
	if (f * fmid >= 0.0) {
		printf("La racine n'est pas dans l'intervalle RTBIS\n");
	}
	rtb = f < 0.0 ? (dx = x2 - x1, x1) : (dx = x1 - x2, x2);
	for (j = 1; j <= MAXIT; j++) {
		fmid = F(xmid = rtb + (dx *= 0.5), theta0, v0, y0);
		if (fmid <= 0.0) rtb = xmid;
		if (fabs(dx) < xacc || fabs(fmid) < zeroacc) {
			return rtb;
		}
	}
	printf("Nombre maximal d'itrations atteint dans RTBIS\n");
	return -1;
}
//	[MAIN]  ----------------------------------------------------------------------------------------------------------------------------
//	
//	Titre: Menu principal du travail pratique #1
//	
//	Description: Affiche un menu principal permettant  l'utilisateur de choisir parmi plusieurs options, chaque option reprsente un nonc.
// 
//	INPUT:  - L'utilisateur slectionne une option du menu en entrant le nombre correspondant. 
// 
//	OUTPUT: - 1. Effectue l'addition de deux nombres entiers signs sur 16 bits.
//			- 2. Affiche la valeur de l'epsilon pour les types float et double, ainsi que le nombre de bits significatifs.
//			- 3. Calcule la sommation successive de 1 / n pour un nombre donn d'itrations.
//			- 4. Effectue la sommation ascendante et descendante de nombres rels en simple et double prcision.
//			- 5. Calculer la distance horizontale parcourue par un projectile suivant une trajectoire parabolique.
//			- 6. Quitter le programme.

int main() {
	setlocale(LC_ALL, "");
	int options_menu;
	int selection_menu;
	// Le menu appel simplement les fonctions construites prcdement.
	// Menu pour le Travail Pratique #1
	do {
		nettoyerConsole();// Plus clair lorsqu'on change d'exercice.
		printfEnCouleur("----------------------------------------------------------------------------------------------------------", GRIS);
		printfEnCouleur("Menu Principal", BLEU);
		printfEnCouleur("----------------------------------------------------------------------------------------------------------", GRIS);
		printf("1. Effectuer l'addition de deux nombres entiers signs sur 16 bits.\n");
		printf("2. Afficher la valeur de l'epsilon pour les float et double, ainsi que le nombre de bits significatifs\n");
		printf("3. Calculer la sommation successive de 1/n pour n iterations.\n");
		printf("4. Effectue la sommation ascendante et descendante de nombres rels en simple et double prcision.\n");
		printf("5. Calculer la distance horizontale parcourue par un projectile suivant une trajectoire parabolique.\n");
		printf("6. Quitter le programme\n");
		printfEnCouleur("----------------------------------------------------------------------------------------------------------", GRIS);
		printf("\nEntrez votre choix (1-6) : ");

		selection_menu = scanf_s("%d", &options_menu);
		while (getchar() != '\n');

		if (selection_menu != 1) {
			continue; // On revient au menu sans afficher de message.
		}
		// Options du menu.
		switch (options_menu) {
		case 1:
			// NONC #1
			printf("\n1. Faire la somme de deux nombres entiers signs sur 16 bits.\n");
			additionSINT();
			break;
		case 2:
			// NONC #2
			printf("\n2. Afficher la valeur du epsilon ainsi que le nombre de chiffres binaires significatifs.\n");
			afficherEpsilon();
			break;
		case 3:
			// NONC #3
			printf("\n3. Calcule de la sommation successive de 1/n pour n iterations.\n");
			sommationSuccessive();
			break;
		case 4:
			// NONC #4
			printf("\n4. La sommation ascendante et descendante de nombres rels.\n");
			for (int n = 1; n <= 3; n++) {
				sommeascf(n);
				sommedescf(n);
				sommeascd(n);
				sommedescd(n);
			}
			pauseContinuer();
			break;
		case 5:
			// Option #5
			printf("5. Afficher la distance horizontale parcourue par un projectile suivant une trajectoire parabolique.\n");
			// Note de cours: printf("\nValeur de la racine (bissection) = %lf m.", rtbis(1, 300, 30, 50, 2, PRECISIONX, PRECISIONZERO));
			// On Appelle  la fonction rtbis en passant les arguments
			printf("\nDistance horizontale parcourue = %lf m.\n", rtbis(1, 300, 30, 50, 0, 0.00000000000001, 0.00000000000001));
			printf("\nOn constate que l'auguementation de la prcision rduit la distance parcourue.");
			pauseContinuer();
			break;
		case 6:
			// Option #6 - Sortie
			printf("\nMerci pour votre temps.\n");
			printf("Frdrick Prusse - PERF20358800\n\n");
			break;
		default:
			printf("Choix non valide, veuillez entrer un nombre entre 1 et 6.\n");
		}
	} while (options_menu != 6);

	return 0;
}