/*
* @nom et Prenom : NOUBI NGUIAM ERICA CAREINE           CODE_PERMANANT : NOUE70260200
* @nom et Prenom : LALONG JEAN THIERRY                  CODE_PERMANANT : LALJ01379200
* @nom et Prenom : TENMA YOUANCHI GUILLAUMAR ARTHUS     CODE_PERMANANT : TENG84350100
* @nom et Prenom : MBAH TANTOH DILAN                    CODE_PERMANANT : MBAD92300200
*/


#include "header.h"
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <math.h>


/*
Fonction qui calcule la valeur de la fonction parabolique, qui calcul la position y (hauteur) d'une balle sur sa
trajectoire en x
*/

// Definition de constantes utiles
const int MAXIT = 100;
const int PI = 3.14159;
const int G = 9.81;
const int PRECISIONX = 0.00000000000000000001;
const int PRECISIONZERO = 0.0000000000000000001;


/*
*@Description Fonction qui calcule la valeur de la fonction parabolique, qui calcul la position y (hauteur) d'une balle sur sa
*trajectoire en x
*/
double F(double x, double theta0, double v0, double y0)
{
	return (tan(theta0*PI/180.0)*x-((G/(2.0*v0*v0*cos(theta0*PI / 180.0)*cos(theta0*PI / 180.0)))*x*x)+y0);
}

/*
* @Description Calcul de la distance en x parcourue par une balle
* @Param 1 x1: borne inferieure des valeurs en x (m)
* @Param 2 x2: borne superieure des valeurs en x (m)
* @Param 3 theta0: angle en degre par rapport de la direction de la balle au depart
* @Param 4 v0: vitesse initiale (m/s)
* @Param 5 y0: hauteur de la balle au depart (m)
* @Param 6 xacc: precision sur la localisation de la racine en x
* @Param 7 zeroacc: pr�cision sur la localisation du 0 de fonction (en y)
* @return aucune valeur en retour
*/

double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc)
{
	int j;
	float dx, f, fmid, xmid, rtb;


	f = F(x1, theta0, v0, y0);
	fmid = F(x2, theta0, v0, y0);
	if (f*fmid >= 0.0) printf("Racine absente de cet intervalle dans RTBIS\n");
	rtb = f < 0.0 ? (dx = x2 - x1, x1) : (dx = x1 - x2, x2);
	for (j = 1; j <= MAXIT; j++) {
		fmid = F(xmid = rtb + (dx *= 0.5), theta0, v0, y0);
		if (fmid <= 0.0) rtb = xmid;
		if (fabs(dx) < xacc || fabs(fmid) < zeroacc)
		{
			printf("\nNombre d'iterations: %d dx: %17.25lf f(rtb): %17.25lf\n", j,dx,fmid);
			return rtb;
		}
	}
	printf("Trop de bissections dans RTBIS\n");
}
