// prenom et nom: Mohamed Heni Baabaa            code permaneant: BAAM79260100
// prenom et nom: Ahmed Ammar                    code permaneant: AMMA66290400

#include <stdio.h>
#include <stdbool.h>
#include <limits.h>

// Fonction : validationDeDebordement
// Description : Vérifie si un entier n est dans la plage des valeurs acceptables pour un short int.
// INPUT : n (int) - Entier à vérifier
// OUTPUT : bool - Vrai si n est dans la plage acceptable pour un short int, Faux sinon
bool validationDeDebordement(int n)
{
  return n >= SHRT_MIN && n <= SHRT_MAX;
}

// Fonction : scanNumber
// Description : Demande à l'utilisateur d'entrer un nombre entier signé jusqu'à ce que celui-ci soit dans la plage acceptable pour un short int.
// INPUT : Aucun
// OUTPUT : short int - Nombre entier signé dans la plage acceptable pour un short int
short int scanNumber()
{
  int n;
  printf("Entrez un nombre entier signe : ");
  do
  {
    scanf("%d", &n);
  } while (!validationDeDebordement(n));
  return n;
}

// Fonction : additionSINT
// Description : Effectue l'addition de deux nombres entiers signés et affiche le résultat ainsi que le dépassement de capacité, s'il y a lieu.
// INPUT : 
//          n1 (short int) - Premier nombre entier signé
//          n2 (short int) - Deuxième nombre entier signé
// OUTPUT : Aucun (affiche le résultat à l'écran)
void additionSINT(short int n1, short int n2)
{
  short int sum = n1 + n2;
  printf("La somme des deux nombres = %hi\n", sum);

  if (n1 > 0 && n2 > 0 && sum < 0)
  {
    printf("On a un debordement positif");
  }
  else if (n1 < 0 && n2 < 0 && sum > 0)
  {
    printf("On a un debordement negatif");
  }
  else
    printf("Ce resultat est correct");
}

int main()
{
  short int n1, n2;

  n1 = scanNumber();
  n2 = scanNumber();

  additionSINT(n1, n2);

  return 0;
}
