// prenom et nom: Mohamed Heni Baabaa            code permaneant: BAAM79260100
// prenom et nom: Ahmed Ammar                    code permaneant: AMMA66290400

#include <stdio.h>
#include <math.h>

// Fonction : sommef
// Description : Calcule la somme d'une série en utilisant des flottants (float) jusqu'à un certain nombre d'itérations.
// INPUT : n (int) - Nombre d'itérations pour la somme
// OUTPUT : float - Somme calculée
float sommef(int n)
{
    float sum = 0.0f;
    for (int i = 1; i <= n; i++)
    {
        sum += 1.0f / n; 
    }
    return sum;
}

// Fonction : sommed
// Description : Calcule la somme d'une série en utilisant des doubles (double) jusqu'à un certain nombre d'itérations.
// INPUT : n (int) - Nombre d'itérations pour la somme
// OUTPUT : double - Somme calculée
double sommed(int n)
{
    double sum = 0.0;
    for (int i = 1; i <= n; i++)
    {
        sum += 1.0 / n;
    }
    return sum;
}

int main()
{
    int n;

    printf("Donnez un multiple de 100 (soit 100, 1000, ou 10000)  : ");
    do
    {
        scanf("%d", &n); 
    } while (!(n == 100 || n == 1000 || n == 10000)); 

    float SP = sommef(n); 
    double DP = sommed(n); 

    printf("\nSomme successive (float): %.30f Pour N = %d\n", SP, n);
    printf("Erreur (float) : %.30f Pour N = %d \n", 1 - SP, n);

    printf("\nSomme successive (double): %.30lf Pour N = %d\n", DP, n);
    printf("Erreur (double) : %.30lf Pour N = %d \n", 1 - DP, n);

    return 0;
}
