// prenom et nom: Mohamed Heni Baabaa            code permaneant: BAAM79260100
// prenom et nom: Ahmed Ammar                    code permaneant: AMMA66290400

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdbool.h>

#define PI 3.14159
#define G 9.81
#define MAXIT 100

#define PRECISIONX 500
#define PRECISIONZERO 0.00000000000000000001

double F(double x, double theta0, double v0, double y0);
double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc);

int main()
{
    printf("\n Valeur de la racine (bissection) = %lf m.", rtbis(1, 300, 30, 50, 2, PRECISIONX, PRECISIONZERO));

    return 0;
}

double F(double x, double theta0, double v0, double y0)
{
    return (tan(theta0 * PI / 180.0) * x - ((G / (2.0 * v0 * v0 * cos(theta0 * PI / 180.0) * cos(theta0 * PI / 180.0))) * x * x) + y0);
}


double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc)
{
    int j;
    float dx, f, fmid, xmid, rtb;

    f = F(x1, theta0, v0, y0);
    fmid = F(x2, theta0, v0, y0);
    if (f * fmid >= 0.0)
        printf("Racine absente de cet intervalle dans RTBIS\n");
    rtb = f < 0.0 ? (dx = x2 - x1, x1) : (dx = x1 - x2, x2);
    for (j = 1; j <= MAXIT; j++)
    {
        fmid = F(xmid = rtb + (dx *= 0.5), theta0, v0, y0);
        if (fmid <= 0.0)
            rtb = xmid;
        if (fabs(dx) < xacc || fabs(fmid) < zeroacc)
        {
            printf("\nNombre d'iterations: %d dx: %17.15lf f(rtb): %17.15lf", j, dx, fmid);
            return rtb;
        }
    }
    printf("Trop de bissections dans RTBIS\n");
}