/*****Mboko birghe breitzer***************

Fonctions epsilonf() et epsilond() :

La fonction epsilonf() calcule l'epsilon pour la reprsentation en rel simple prcision (SP).

La fonction epsilond() calcule l'epsilon pour la reprsentation en rel double prcision (DP).

Les deux fonctions utilisent une boucle while pour diviser un nombre par 2 jusqu' ce que la somme de ce nombre avec 1.0 ne change pas.
Cela dtermine la plus petite valeur qui peut tre ajoute  1.0 et affecter le rsultat, donc l'epsilon.
Les macros prdfinies __FLT_DIG__ et __DBL_DIG__ sont utilises pour obtenir
 le nombre de chiffres significatifs pour les types float et double respectivement.
Fonction main() :

La fonction main() appelle les fonctions epsilonf() et epsilond() pour calculer et afficher l'epsilon pour les reprsentations SP et DP.
Affichage des rsultats :

Les rsultats sont affichs sur la console avec printf().
Pour chaque reprsentation, l'epsilon est affich en notation scientifique (%e) ainsi que le nombre de chiffres binaires significatifs.
*/


#include <stdio.h>

// Fonction pour calculer l'epsilon pour la reprsentation en rel simple prcision (SP)
void epsilonf() {
    float epsilon = 1.0f; // Initialisation de epsilon  1.0 en SP
    // Boucle pour diviser epsilon par 2 jusqu' ce que la condition soit fausse
    while (1.0f + epsilon / 2.0f != 1.0f) {
        epsilon /= 2.0f;
    }
    // Calcul du nombre de chiffres binaires significatifs pour float en utilisant __FLT_DIG__
    int significatif = __FLT_DIG__ - 1;

    // Affichage de l'epsilon et du nombre de chiffres binaires significatifs
    printf("Epsilon pour la reprsentation relle simple prcision (SP) (float) : %e\n", epsilon);
    printf("Nombre de chiffres binaires significatifs : %d\n", significatif);
}

// Fonction pour calculer l'epsilon pour la reprsentation en rel double prcision (DP)
void epsilond() {
    double epsilon = 1.0; // Initialisation de epsilon  1.0 en DP
    // Boucle pour diviser epsilon par 2 jusqu' ce que la condition soit fausse
    while (1.0 + epsilon / 2.0 != 1.0) {
        epsilon /= 2.0;
    }
    // Calcul du nombre de chiffres binaires significatifs pour double en utilisant __DBL_DIG__
    int significatif = __DBL_DIG__ - 1;

    // Affichage de l'epsilon et du nombre de chiffres binaires significatifs
    printf("Epsilon pour la reprsentation relle double prcision (DP) (double) : %e\n", epsilon);
    printf("Nombre de chiffres binaires significatifs : %d\n", significatif);
}

// Fonction principale du programme
int main() {
    epsilonf(); // Appel de la fonction epsilonf pour calculer et afficher l'epsilon en SP
    epsilond(); // Appel de la fonction epsilond pour calculer et afficher l'epsilon en DP

    return 0; // Indique que le programme s'est termin avec succs
}
