/***************Mboko birghe breitzer************

Le programme commence par inclure les bibliothques math.h, stdio.h, et stdlib.h
Inclusion de bibliothques pour fonctions mathmatiques et entres/sorties. Dfinition de constantes. Prototypes de fonctions dclars.

Les prototypes des fonctions F() et rtbis() sont dclars pour informer le compilateur de leur existence avant leur utilisation dans la fonction main().
Fonction F() :

Cette fonction calcule la valeur de la fonction parabolique qui reprsente la position en y (hauteur) de la balle sur sa trajectoire en fonction de la position en x.
La formule utilise prend en compte l'angle de tir initial, la vitesse initiale et la hauteur initiale.
Fonction rtbis() :

La fonction de bissection trouve la distance parcourue par la balle jusqu'au sol. Paramtres : bornes, angle, vitesse, hauteur, prcisions.
 Elle divise l'intervalle jusqu' atteindre la prcision. Renvoie la distance.

Dans la fonction main(), les valeurs des bornes initiales, de l'angle de tir initial, de la vitesse initiale et de la hauteur initiale sont passes  la fonction rtbis() pour calculer la distance parcourue par la balle jusqu' ce qu'elle touche le sol.
Les rsultats sont affichs  l'aide de la fonction printf().

*/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>

// Dfinition de constantes utiles
#define MAXIT 100
#define PI 3.14159
#define G 9.81
#define PRECISIONX 0.00000000000000000001
#define PRECISIONZERO 0.0000000000000000001

// Prototypes des fonctions
double F(double x, double theta0, double v0, double y0);
double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc);

void someascf(){

}
int main()
{
    PRECISIONX;
    PRECISIONZERO;

    printf("\n Valeur de la racine (bissection) = %lf m.", rtbis(1, 300, 30, 50, 2, PRECISIONX, PRECISIONZERO));
}

/*
   Fonction qui calcule la valeur de la fonction parabolique, qui calcule la position y (hauteur) d'une balle sur sa trajectoire en x
*/
double F(double x, double theta0, double v0, double y0)
{
    return (tan(theta0 * PI / 180.0) * x - ((G / (2.0 * v0 * v0 * cos(theta0 * PI / 180.0) * cos(theta0 * PI / 180.0))) * x * x) + y0);
}

/*
   Fonction qui calcule la valeur de la position x pour y = 0 donnant la distance parcourue d'une balle
*/
double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc)
{
    int j;                   // Dclaration d'une variable entire j qui sera utilise comme compteur dans la boucle.
    double dx, f, fmid, xmid, rtb; // Dclaration de variables de type double qui seront utilises pour stocker des valeurs intermdiaires.

    f = F(x1, theta0, v0, y0);
    fmid = F(x2, theta0, v0, y0);

    // Vrification si les valeurs de f et fmid ont le mme signe. Si c'est le cas, cela signifie qu'il n'y a pas de racine dans l'intervalle donn, et un message d'erreur est affich.
    if (f * fmid >= 0.0)
        printf("Racine absente de cet intervalle dans RTBIS\n");

    rtb = f < 0.0 ? (dx = x2 - x1, x1) : (dx = x1 - x2, x2);

    for (j = 1; j <= MAXIT; j++)
    {
        fmid = F(xmid = rtb + (dx *= 0.5), theta0, v0, y0);

        if (fmid <= 0.0)
            rtb = xmid;

        if (fabs(dx) < xacc || fabs(fmid) < zeroacc)
        {
            // Cette ligne affiche les valeurs de j, dx et f(rtb) en utilisant un format spcifi.
            printf("\nNombre d'iterations: %d dx: %17.15lf f(rtb): %17.15lf", j, dx, fmid);
            return rtb; // Cette ligne retourne la valeur de rtb, qui est la racine.
        }
    }

    printf("Trop de bissections dans RTBIS\n");
    return 0;
}
