#include <stdio.h>

// Fonction pour la somme de deux nombres entiers signés sur 16 bits

// INPUT : short int n1, short int n2 )

void additionSINT() {
    short int n1, n2;
    
    printf("Entrez le premier nombre entier signé : ");
    scanf("%hd", &n1);
    printf("Entrez le deuxième nombre entier signé : ");
    scanf("%hd", &n2);
    
    short int sum = n1 + n2;
    
    printf("Résultat de la somme : %hd\n", sum);
    
    if ((n1 > 0 && n2 > 0 && sum < 0) || (n1 < 0 && n2 < 0 && sum > 0)) {
        printf("Débordement positif détecté.\n");
    } else if ((n1 < 0 && n2 > 0 && sum >= 0) || (n1 > 0 && n2 < 0 && sum <= 0)) {
        printf("Débordement négatif détecté.\n");
    } else {
        printf("La somme est correcte.\n");
    }
}

// Fonction pour évaluer l'epsilon de l'architecture INTEL (simple précision)


void epsilonf() {
    float epsilon = 1.0;
    
    while ((float)(1.0 + epsilon) != 1.0) {
        epsilon /= 2.0;
    }
    
    printf("Epsilon en simple précision : %e\n", epsilon);
}

// Fonction pour évaluer l'epsilon de l'architecture INTEL (double précision)


void epsilond() {
    double epsilon = 1.0;
    
    while ((double)(1.0 + epsilon) != 1.0) {
        epsilon /= 2.0;
    }
    
    printf("Epsilon en double précision : %e\n", epsilon);
}

// Fonction pour la sommation successive de 1/n pour n itérations (simple précision)

// INPUT : int n (nombre d'itérations)

void sommef(int n) {
    float sum = 0.0;
    
    for (int i = 1; i <= n; ++i) {
        sum += 1.0 / i;
    }
    
    printf("Résultat de la sommation en simple précision pour %d itérations : %f\n", n, sum);
    printf("Erreur de calcul : %f\n", 0.693147 - sum);
}

// Fonction pour la sommation successive de 1/n pour n itérations (double précision)

// INPUT : int n 
void sommed(int n) {
    double sum = 0.0;
    
    for (int i = 1; i <= n; ++i) {
        sum += 1.0 / i;
    }
    
    printf("Résultat de la sommation en double précision pour %d itérations : %lf\n", n, sum);
    printf("Erreur de calcul : %lf\n", 0.693147 - sum);
}

// Fonction pour la sommation ascendante de nombres réels (simple précision)

void sommeascf() {
    float sum = 0.0;
    
    for (int i = 1; i <= 32767; ++i) {
        sum += 1.0 / i;
    }
    
    printf("Sommation ascendante (SP) pour n=1 : %f\n", sum);
}

// Fonction pour la sommation descendante de nombres réels 


void sommedescf() {
    float sum = 0.0;
    
    for (int i = 32767; i >= 1; --i) {
        sum += 1.0 / i;
    }
    
    printf("Sommation descendante (SP) pour n=1 : %f\n", sum);
}

// Fonction pour la sommation ascendante de nombres réels (double précision)


void sommeascd() {
    double sum = 0.0;
    
    for (int i = 1; i <= 32767; ++i) {
        sum += 1.0 / i;
    }
    
    printf("Sommation ascendante (DP) pour n=1 : %lf\n", sum);
}

// Fonction pour la sommation descendante de nombres réels 


void sommedescd() {
    double sum = 0.0;
    
    for (int i = 32767; i >= 1; --i) {
        sum += 1.0 / i;
    }
    
    printf("Sommation descendante (DP) pour n=1 : %lf\n", sum);
}

// Fonction principale
int main() {
    additionSINT();
    
    epsilonf();
    epsilond();
    
    int n;
    printf("Entrez le nombre d'itérations pour la sommation : ");
    scanf("%d", &n);
    
    sommef(n);
    sommed(n);
    
    sommeascf();
    sommedescf();
    sommeascd();
    sommedescd();
    
    return 0;
}