//membres du groupe:
//-Essam Ndi Brandon Fustel Zizou
//-STEVE LOIC KUIDA DJAPO
#include <stdio.h>
#include "util-Rtbis-Trajectoire.cpp" // Importation du module util-Rtbis-Trajectoire

// Pour executer le programme c sous windows utilisez le fichier program.exe
// Par contre pour l'exécuter sous un système macos ou linux utilisez le fichier program.out

/* ----------------------------------------------------------------------------
       Définition des prototypes
   ---------------------------------------------------------------------------- 
*/
void additionSINT();
void epsilonf();
void epsilond();
void sommef();
void sommed();
void sommeascf();
void sommeascd();
void sommedescf();
void sommedescd();
char afficherMenu();

/*  -------------------------------------------------------------------     */



/* ----------------------------------------------------------------------------
       Définition de la fonction principale
   ---------------------------------------------------------------------------- 
*/

int main(void)
{
	/* code */
	char choix = 'o';

    while (choix != 'n' && choix != 'N') {
        choix = afficherMenu();

        switch (choix) {
            case '1':
                additionSINT();
                break;
                
            case '2':
                epsilonf();
                break;
            case '3':
                epsilond();
                break;
            case '4':
                sommef();
                break;
            case '5':
                sommed();
                break;
            case '6':
                sommeascf();
                break;
            case '7':
                sommedescf();
                break;
            case '8':
                sommeascd();
                break;
            case '9':
                sommedescd();
                break;
            case '0':
                printf("\n Valeur de la racine (bissection) = %lf m.\n", rtbis(1, 300, 30, 50, 2, PRECISIONX, PRECISIONZERO));
                break;
            case 'n':
            case 'N':
                printf  ("Fin du programme.");
                break;

            default:
                printf  ("Choix invalide. Veuillez réessayer.") ;
                break;
        }
    }
	return 0;
}

/*  -------------------------------------------------------------------     */

/* ----------------------------------------------------------------------------
	   Définition des fonctions
   ---------------------------------------------------------------------------- 
*/

// Fonction pour effectuer l'addition de deux nombres entiers signés 16 bits
void additionSINT() {
    printf("Entrez deux nombres entiers signés sur 16 bits:\n");
    short int n1, n2;
    scanf("%hd %hd", &n1, &n2);

    int sum = n1 + n2;

    printf("Résultat de l'addition : %d\n", sum);

    // Vérification du débordement positif et négatif
    if ((n1 > 0 && n2 > 0 && sum < 0) || (n1 < 0 && n2 < 0 && sum > 0)) {
        printf("Débordement négatif détecté.\n");
    }
    else if ((n1 > 0 && n2 > 0 && sum > 0) || (n1 < 0 && n2 < 0 && sum < 0)) {
        printf("Débordement positif détecté.\n");
    }
    else {
        printf("Le résultat est correct.\n");
    }
}

// Fonction pour évaluer l'epsilon de la représentation réelle simple précision (SP)
void epsilonf() {
    float eps = 1.0, unpluseps = 1 + eps;
    int n = 0;


    while (unpluseps > 1.0) {
        eps /= 2.0;
        unpluseps = 1 +eps;
        n++;
    }

    eps = eps * 2;
    n = n-1;

    printf("\nValeur de eps = %12.10f et n = %d\n", eps, n);
}

// Fonction pour évaluer l'epsilon de la représentation réelle double précision (DP)
void epsilond() {
    double eps = 1.0, unpluseps = 1 + eps;
    int n = 0;


    while (unpluseps > 1.0) {
        eps /= 2.0;
        unpluseps = 1 +eps;
        n++;
    }

    eps = eps * 2;
    n = n-1;

    printf("\nValeur de eps = %20.18lf et n = %d\n", eps, n);
}

// Fonction pour effectuer la sommation successive de 1/n en utilisant la représentation réelle simple précision (SP)
void sommef() {
    int n;
    float somme = 0.0;

    printf("Entrez un nombre entier multiple de 100 pour le nombre d'itérations (SP) :\n");
    scanf("%d", &n);

    // Validation de n pour vérifier s'il est un multiple de 100
    if (n % 100 != 0) {
        printf("Nombre d'itérations invalide. Doit être un multiple de 100.\n");
        return;
    }

    for (int i = 1; i <= n; i++) {
        somme += 1.0 / i;
    }

    printf("Nombre d'itérations : %d\n", n);
    printf("Résultat de la sommation (SP) : %f\n", somme);
    printf("Erreur de calcul (SP) : %f\n", (1.0 - somme));
}

// Fonction pour effectuer la sommation successive de 1/n en utilisant la représentation réelle double précision (DP)
void sommed() {
    int n;
    double somme = 0.0;

    printf("Entrez un nombre entier multiple de 100 pour le nombre d'itérations (DP) :\n");
    scanf("%d", &n);

    // Validation de n pour vérifier s'il est un multiple de 100
    if (n % 100 != 0) {
        printf("Nombre d'itérations invalide. Doit être un multiple de 100.\n");
        return;
    }

    for (int i = 1; i <= n; i++) {
        somme += 1.0 / i;
    }

    printf("Nombre d'itérations : %d\n", n);
    printf("Résultat de la sommation (DP) : %lf\n", somme);
    printf("Erreur de calcul (DP) : %lf\n", (1.0 - somme));
}

// Fonction pour effectuer la sommation ascendante de (1/in) pour n = 1, 2 et 3 en utilisant la représentation réelle simple précision (SP)
void sommeascf() {
    int exposants[] = {1, 2, 3};
    int taille = sizeof(exposants) / sizeof(exposants[0]);

    for (int i = 0; i < taille; i++) {
        int n = 32767;
        float somme = 0.0;

        printf("Exposant : %d\n", exposants[i]);

        for (int j = 1; j <= n; j++) {
            somme += 1.0 / j;
        }

        printf("Résultat de la sommation (SP) : %f\n", somme);
        printf("\n");
    }
}

// Fonction pour effectuer la sommation descendante de (1/in) pour n = 1, 2 et 3 en utilisant la représentation réelle simple précision (SP)
void sommedescf() {
    int exposants[] = {1, 2, 3};
    int taille = sizeof(exposants) / sizeof(exposants[0]);

    for (int i = 0; i < taille; i++) {
        int n = 32767;
        float somme = 0.0;

        printf("Exposant : %d\n", exposants[i]);

        for (int j = n; j >= 1; j--) {
            somme += 1.0 / j;
        }

        printf("Résultat de la sommation (SP) : %f\n", somme);
        printf("\n");
    }
}

// Fonction pour effectuer la sommation ascendante de (1/in) pour n = 1, 2 et 3 en utilisant la représentation réelle double précision (DP)
void sommeascd() {
    int exposants[] = {1, 2, 3};
    int taille = sizeof(exposants) / sizeof(exposants[0]);

    for (int i = 0; i < taille; i++) {
        int n = 32767;
        double somme = 0.0;

        printf("Exposant : %d\n", exposants[i]);

        for (int j = 1; j <= n; j++) {
            somme += 1.0 / j;
        }

        printf("Résultat de la sommation (DP) : %lf\n", somme);
        printf("\n");
    }
}

// Fonction pour effectuer la sommation descendante de (1/in) pour n = 1, 2 et 3 en utilisant la représentation réelle double précision (DP)
void sommedescd() {
    int exposants[] = {1, 2, 3};
    int taille = sizeof(exposants) / sizeof(exposants[0]);

    for (int i = 0; i < taille; i++) {
        int n = 32767;
        double somme = 0.0;

        printf("Exposant : %d\n", exposants[i]);

        for (int j = n; j >= 1; j--) {
            somme += 1.0 / j;
        }

        printf("Résultat de la sommation (DP) : %lf\n", somme);
        printf("\n");
    }
}


// Fonction pour afficher le menu et obtenir le choix de l'utilisateur
char afficherMenu() {
    char choix;
    printf ( "=== Menu ===\n" ) ;
    printf ( "0. Calcul de la trajectoire\n" );
    printf ( "1. Addition Signee\n" );
    printf  ("2. Epsilonf\n") ;
    printf  ("3. Epsilond\n") ;
    printf  ("4. sommef\n") ;
    printf  ("5. sommed\n") ;
    printf  ("6. sommeascf\n") ;
    printf  ("7. sommedescf\n") ;
    printf  ("8. sommeascd\n") ;
    printf  ("9. sommedescd\n") ;

    printf  ("N. Quitter\n") ;

    printf  ("Choisissez une action (0 et 9) : ");
    scanf(" %c", &choix);

    return choix;
}

/*  -------------------------------------------------------------------     */